using System;


namespace ConsoleApp7
{
    internal class Program
    {
        static void Main(string[] args)
        {
            string[] s1 = Console.ReadLine().Split();
            Int64 n = Convert.ToInt64(s1[0]);
            Int64 q = Convert.ToInt64(s1[1]);
            Int64[] di = new Int64[n]; Int64[] pi = new Int64[n];
            for (int i = 0; i < n; i++)
            {
                string[] s2 = Console.ReadLine().Split();
                di[i] = Convert.ToInt64(s2[0]);
                pi[i] = Convert.ToInt64(s2[1]);
            }
            Int64[] k = new Int64[q];
            for (int j = 0; j < q; j++)
            { k[j] = Convert.ToInt64(Console.ReadLine()); }
            for (int j = 0; j < q; j++)
            {
                Int64 br = 0; Int64 ne = 0;
                for (int i = 0; i < n; i++)
                {

                    if (di[i] > k[j]) { break; }
                    ne = ne + pi[i];
                    if (k[j] < di[i])

                    { br = ne + (pi[i] - k[j] - 1); }

                    if (k[j] > di[i])
                    {
                        if (di[i] + pi[i] > k[j]) { br = ne - pi[i] + (k[j] - di[i]) + 1; break; }
                        else { br = ne; }
                    }
                    if (k[j] == di[i])
                    { br = (ne - pi[i]) + 1; }
                    if (br >= k[j]) { break; }

                }
                Console.WriteLine(br);
            }
            
            Console.ReadKey();
        }
    }
}